DROP TABLE DATES CASCADE CONSTRAINTS;
DROP TABLE DATER CASCADE CONSTRAINTS;
DROP TABLE HOTEL CASCADE CONSTRAINTS;
DROP TABLE CHAMBRE CASCADE CONSTRAINTS;
DROP TABLE DEPARTEMENT CASCADE CONSTRAINTS;
DROP TABLE SERVICES CASCADE CONSTRAINTS;
DROP TABLE PERSONNES CASCADE CONSTRAINTS;
DROP TABLE CLIENT CASCADE CONSTRAINTS;
DROP TABLE PERSONNEL CASCADE CONSTRAINTS;
DROP TABLE COMMANDER CASCADE CONSTRAINTS;
DROP TABLE RESERVER CASCADE CONSTRAINTS;

CREATE TABLE DATES(
    DateServ DATE,
    HeureServ VARCHAR2(5),
    CONSTRAINT pkDate PRIMARY KEY (DateServ,HeureServ)
);

Create TABLE DATER(
    DateArriv DATE,
    CONSTRAINT pkDateR PRIMARY KEY (DateArriv)
);

CREATE TABLE HOTEL(
    IDHotel NUMBER(5),
    NomHotel VARCHAR2(20),
    VilleHotel VARCHAR2(25),
    RueHotel VARCHAR2(50),
    GPSHotel VARCHAR2(30),
    NbChambre NUMBER(4),
    Qualité NUMBER(1),
    CONSTRAINT pkHotel PRIMARY KEY (IDHotel)
);

CREATE TABLE CHAMBRE(
    NumChambre NUMBER(4),
    IDHotel NUMBER(5),
    CapacitéC NUMBER(2),
    SuperficieC NUMBER(3),
    CONSTRAINT pkChambre PRIMARY KEY (NumChambre,IDHotel),
    CONSTRAINT fkHotel FOREIGN KEY (IDHotel) REFERENCES HOTEL(IDHotel) 
);

CREATE TABLE DEPARTEMENT(
    IDHotel NUMBER(5),
    NomDep VARCHAR2(20),
    NomRespDep VARCHAR2(20),
    NumPostD NUMBER(10),
    CONSTRAINT pkDepartement PRIMARY KEY (IDHotel,NomDep),
    CONSTRAINT fkHotel1 FOREIGN KEY (IDHotel) REFERENCES HOTEL(IDHotel)
);

CREATE TABLE SERVICES(
    IDServices NUMBER(5),
    NomService VARCHAR2(20),
    DescService VARCHAR2(100),
    PrixService NUMBER(4),
    CONSTRAINT pkService PRIMARY KEY (IDServices)
);

CREATE TABLE PERSONNES(
    IDPers NUMBER(5),
    NomPers VARCHAR2(20),
    AdressePers VARCHAR2(100),
    DdNPers DATE,
    CONSTRAINT pkPers PRIMARY KEY (IDPers)
);

CREATE TABLE CLIENT(
    IDPersC NUMBER(5),
    NationalitéC VARCHAR2(20),
    CONSTRAINT fkPersC FOREIGN KEY (IDPersC) REFERENCES PERSONNES(IDPers)
);

CREATE TABLE PERSONNEL(
    IDPersP NUMBER(5),
    Fonction VARCHAR2(20),
    NomDep VARCHAR2(20),
    IDHotel NUMBER(5),
    CONSTRAINT fkPersP FOREIGN KEY (IDPersP) REFERENCES PERSONNES(IDPers),
    CONSTRAINT fkDepartement FOREIGN KEY (NomDep,IDHotel) REFERENCES DEPARTEMENT(NomDep,IDHotel)
);

CREATE TABLE COMMANDER(
    IDHotel NUMBER(5),
    NumChambre NUMBER(4),
    DateServ DATE,
    HeureServ VARCHAR2(5),
    QuantitéServ NUMBER(2),
    ServiceRegle NUMBER(1),
    IDServices NUMBER(5),
    CONSTRAINT pkCommander PRIMARY KEY (IDHotel,NumChambre,DateServ,HeureServ),
    CONSTRAINT fkChambre FOREIGN KEY (IDHotel,NumChambre) REFERENCES CHAMBRE(IDHotel,NumChambre),
    CONSTRAINT fkDate FOREIGN KEY (DateServ,HeureServ) REFERENCES DATES(DateServ,HeureServ),
    CONSTRAINT fkServices FOREIGN KEY (IDServices) REFERENCES SERVICES(IDServices)
);

CREATE TABLE RESERVER(
    IDPersC NUMBER(5),
    DateArriv DATE,
    IDHotel NUMBER(5),
    NumChambre NUMBER(4),
    DateDep DATE,
    PrixReserv NUMBER(4),
    NbAdulte NUMBER(2),
    NbEnfant NUMBER(2),
    CONSTRAINT pkReserver PRIMARY KEY (IDPersC,DateArriv),
    CONSTRAINT fkClient FOREIGN KEY (IDPersC) REFERENCES PERSONNES(IDPers),
    CONSTRAINT fkDateR FOREIGN KEY (DateArriv) REFERENCES DATER(DateArriv),
    CONSTRAINT fkChambre1 FOREIGN KEY (IDHotel,NumChambre) REFERENCES CHAMBRE(IDHotel,NumChambre) 
);

INSERT INTO DATER(DateArriv)
VALUES(TO_DATE('14042021','DDMMYY'));

INSERT INTO DATES(DateServ,HeureServ)
VALUES (TO_DATE('15042021','DDMMYY'),'12:43');

INSERT INTO HOTEL(IDHotel,NomHotel,VilleHotel,RueHotel,GPSHotel,NbChambre,Qualité)
VALUES ( 00001 , 'Ibiza' , 'Nice', 'Allée de Richelieu', '43.7031739.7.1827724', 2321, 5 );

INSERT INTO CHAMBRE(NumChambre,IDHotel,CapacitéC,SuperficieC)
VALUES (0016, 00001,8,20);

INSERT INTO DEPARTEMENT(IDHotel,NomDep,NomRespDep,NumPostD)
VALUES (00001,'Cuisine','Jean-Pierre',0237293614);

INSERT INTO SERVICES(IDServices,NomService,DescService,PrixService)
VALUES (15001,'Self-Service','DATER(
    DateArriv DATE,Service qui propose de se faire livrée dans hotel',15);

INSERT INTO PERSONNES(IDPers,NomPers,AdressePers,DdNPers)
VALUES (00063,'Mathieu','34 rue du hameau,Menton', TO_DATE('15041992','DDMMYY'));
INSERT INTO PERSONNES(IDPers,NomPers,AdressePers,DdNPers)
VALUES (10045,'Jean-Pierre','49 rue de la montée,Menton', TO_DATE('10051990','DDMMYY'));

INSERT INTO CLIENT(IDPersC,NationalitéC)
VALUES (00063,'Française');

INSERT INTO PERSONNEL(IDPersP,Fonction,NomDep,IDHotel)
VALUES (10045,'Gérant','Cuisine',00001);

INSERT INTO COMMANDER(IDHotel,NumChambre,DateServ,HeureServ,QuantitéServ,ServiceRegle,IDServices)
VALUES (00001,0016,TO_DATE('15042021','DDMMYY'),'12:43',3,1,15001);

INSERT INTO RESERVER(IDPersC,DateArriv,IDHotel,NumChambre,DateDep,PrixReserv,NbAdulte,NbEnfant)
VALUES (00063,TO_DATE('14042021','DDMMYY'),00001,0016,TO_DATE('16042021','DDMMYY'),980,2,0);